Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
XFileDataNodeReference Class Reference

This is a nested reference to an instance of a template object, declared via the syntax: More...

`#include "xFileDataNodeReference.h"`

Inheritance diagram for XFileDataNodeReference:

## Public Member Functions
| XFileDataNodeReference (XFileDataNodeTemplate *object)
virtual TypeHandle | force_init_type ()
XFileDataNodeTemplate * | get_object () const
| Returns the actual data object being referenced.
XFileTemplate * | get_template () const
virtual TypeHandle | get_type () const
virtual bool | is_complex_object () const
| Returns true if this kind of data object is a complex object that can hold nested data elements, false otherwise.
virtual bool | is_reference () const
| Returns true if this node represents an indirect reference to an object defined previously in the file.
virtual void | write_text (std::ostream &out, int indent_level) const
| Writes a suitable representation of this node to an .x file in text mode.
Public Member Functions inherited from XFileDataNode
| XFileDataNode (XFile *x_file, const std::string &name, XFileTemplate *xtemplate)
const XFileDataNode & | get_data_child (int n) const
| Since the children of an XFileDataNode are syntactically constrained to themselves be XFileDataNodes, this is a convenience function that returns the same thing as XFileNode::get_child(), but it is cast to a type XFileDataNode and dereferenced.
XFileTemplate * | get_template () const
| Returns the template used to define this data object.
const std::string & | get_template_name () const
| A convenience function to return the name of the template used to define this data object.
virtual std::string | get_type_name () const
| Returns a string that represents the type of object this data object represents.
virtual bool | is_object () const
| Returns true if this node represents a data object that is the instance of some template, or false otherwise.
virtual bool | is_standard_object (const std::string &template_name) const
| Returns true if this node represents an instance of the standard template with the indicated name, or false otherwise.
Public Member Functions inherited from XFileNode
| XFileNode (XFile *x_file, const std::string &name)
void | add_child (XFileNode *node)
| Adds the indicated node as a child of this node.
XFileDataNode * | add_Frame (const std::string &name)
| Creates a new Frame instance, as a child of this node.
XFileDataNode * | add_FrameTransformMatrix (const LMatrix4d &mat)
| Creates a new FrameTransformMatrix instance, as a child of this node.
XFileDataNode * | add_Material (const std::string &name, const LColor &face_color, double power, const LRGBColor &specular_color, const LRGBColor &emissive_color)
| Creates a new Material instance, as a child of this node.
XFileDataNode * | add_Mesh (const std::string &name)
| Creates a new Mesh instance, as a child of this node.
XFileDataNode * | add_MeshMaterialList (const std::string &name)
| Creates a new MeshMaterialList instance, as a child of this node.
XFileDataNode * | add_MeshNormals (const std::string &name)
| Creates a new MeshNormals instance, as a child of this node.
XFileDataNode * | add_MeshTextureCoords (const std::string &name)
| Creates a new MeshTextureCoords instance, as a child of this node.
XFileDataNode * | add_MeshVertexColors (const std::string &name)
| Creates a new MeshVertexColors instance, as a child of this node.
XFileDataNode * | add_TextureFilename (const std::string &name, const Filename &filename)
| Creates a new TextureFilename instance, as a child of this node.
virtual void | clear ()
| Removes all children from the node, and otherwise resets it to its initial state.
virtual bool | fill_zero_data (XFileDataObject *object) const
| This is similar to repack_data(), except it is used to fill the initial values for a newly-created template object to zero.
XFileNode * | find_child (const std::string &name) const
| Returns the child with the indicated name, if any, or NULL if none.
int | find_child_index (const std::string &name) const
| Returns the index number of the child with the indicated name, if any, or -1 if none.
int | find_child_index (const XFileNode *child) const
| Returns the index number of the indicated child, or -1 if none.
XFileNode * | find_descendent (const std::string &name) const
| Returns the first child or descendent found with the indicated name after a depth-first search, if any, or NULL if none.
XFileNode * | get_child (int n) const
| Returns the nth child of this node.
virtual const WindowsGuid & | get_guid () const
| If has_guid() returned true, returns the particular GUID associated with this node.
int | get_num_children () const
| Returns the list of children of this node.
int | get_num_objects () const
| Returns the list of child objects of this node.
XFileDataNode * | get_object (int n) const
| Returns the nth child object of this node.
XFile * | get_x_file () const
virtual bool | has_guid () const
| Returns true if this node has a GUID associated.
virtual bool | is_template_def () const
| Returns true if this node represents the definition of some template.
virtual bool | matches (const XFileNode *other) const
| Returns true if the node, particularly a template node, is structurally equivalent to the other node (which must be of the same type).
virtual bool | repack_data (XFileDataObject *object, const XFileParseDataList &parse_data_list, PrevData &prev_data, size_t &index, size_t &sub_index) const
| This is called on the template that defines an object, once the data for the object has been parsed.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from XFileDataObject
| XFileDataObject (const XFileDataDef *data_def=nullptr)
XFileDataObject & | add_Coords2d (XFile *x_file, const LVecBase2d &coords)
| Appends a new Coords2d instance.
XFileDataObject & | add_double (double double_value)
| Appends a new floating-point value to the data object, if it makes sense to do so.
virtual bool | add_element (XFileDataObject *element)
| Adds the indicated element as a nested data element, if this data object type supports it.
XFileDataObject & | add_IndexedColor (XFile *x_file, int index, const LColor &color)
| Appends a new IndexedColor instance.
XFileDataObject & | add_int (int int_value)
| Appends a new integer value to the data object, if it makes sense to do so.
XFileDataObject & | add_MeshFace (XFile *x_file)
| Appends a new MeshFace instance.
XFileDataObject & | add_string (const std::string &string_value)
| Appends a new string value to the data object, if it makes sense to do so.
XFileDataObject & | add_Vector (XFile *x_file, const LVecBase3d &vector)
| Appends a new Vector instance.
double | d () const
| Unambiguously returns the object's representation as a double, or 0.0 if the object has no double representation.
const XFileDataDef * | get_data_def () const
| Returns the data object that this object is represented by, if any, or NULL if there is none.
int | i () const
| Unambiguously returns the object's representation as an integer, or 0 if the object has no integer representation.
LMatrix4d | mat4 () const
| Returns the object's representation as an LMatrix4d.
void | operator= (const LMatrix4d &mat)
| Stores the indicated Matrix value into the object, if it makes sense to do so.
void | operator= (const LVecBase2d &vec)
| Stores the indicated Vec2 value into the object, if it makes sense to do so.
void | operator= (const LVecBase3d &vec)
| Stores the indicated Vec3 value into the object, if it makes sense to do so.
void | operator= (const LVecBase4d &vec)
| Stores the indicated Vec4 value into the object, if it makes sense to do so.
void | operator= (const std::string &string_value)
| Stores the indicated string value into the object, if it makes sense to do so.
void | operator= (double double_value)
| Stores the indicated floating-point value into the object, if it makes sense to do so.
void | operator= (int int_value)
| Stores the indicated integer value into the object, if it makes sense to do so.
XFileDataObject & | operator[] (const std::string &name)
| Returns the named nested object within this object.
const XFileDataObject & | operator[] (const std::string &name) const
| Returns the named nested object within this object.
XFileDataObject & | operator[] (int n)
| Returns the nth nested object within this object.
const XFileDataObject & | operator[] (int n) const
| Returns the nth nested object within this object.
virtual void | output_data (std::ostream &out) const
| Writes a suitable representation of this node to an .x file in text mode.
std::string | s () const
| Unambiguously returns the object's representation as a string, or empty string if the object has no string representation.
void | set (const LMatrix4d &mat)
| Stores the indicated Matrix value into the object, if it makes sense to do so.
void | set (const LVecBase2d &vec)
| Stores the indicated Vec2 value into the object, if it makes sense to do so.
void | set (const LVecBase3d &vec)
| Stores the indicated Vec3 value into the object, if it makes sense to do so.
void | set (const LVecBase4d &vec)
| Stores the indicated Vec4 value into the object, if it makes sense to do so.
void | set (const std::string &string_value)
| Stores the indicated string value into the object, if it makes sense to do so.
void | set (double double_value)
| Stores the indicated floating-point value into the object, if it makes sense to do so.
void | set (int int_value)
| Stores the indicated integer value into the object, if it makes sense to do so.
int | size () const
| Returns the number of nested data objects within this object.
LVecBase2d | vec2 () const
| Returns the object's representation as an LVecBase2d.
LVecBase3d | vec3 () const
| Returns the object's representation as an LVecBase3d.
LVecBase4d | vec4 () const
| Returns the object's representation as an LVecBase4d.
virtual void | write_data (std::ostream &out, int indent_level, const char *separator) const
| Writes a suitable representation of this node to an .x file in text mode.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from XFileDataNode
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from XFileNode
static TypeHandle | get_class_type ()
static void | init_type ()
static std::string | make_nice_name (const std::string &str)
| Transforms the indicated egg name to a name that is acceptable for a node in the X File format.
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from XFileDataObject
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from XFileNode
typedef pmap< const XFileDataDef *, XFileDataObject * > | PrevData
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from Namable
| get_name
| set_name
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

This is a nested reference to an instance of a template object, declared via the syntax:

{ InstanceName }

in the X File.

Definition at line 29 of file xFileDataNodeReference.h.

## Constructor & Destructor Documentation

## ◆ XFileDataNodeReference()

XFileDataNodeReference::XFileDataNodeReference | ( | XFileDataNodeTemplate * | object | ) |

Definition at line 22 of file xFileDataNodeReference.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle XFileDataNodeReference::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from XFileDataNode.

Definition at line 61 of file xFileDataNodeReference.h.

## ◆ get_class_type()

static TypeHandle XFileDataNodeReference::get_class_type | ( |  | ) |
| inline static

Definition at line 50 of file xFileDataNodeReference.h.

## ◆ get_object()

XFileDataNodeTemplate * XFileDataNodeReference::get_object | ( |  | ) | const
| inline

Returns the actual data object being referenced.

Definition at line 17 of file xFileDataNodeReference.I.

## ◆ get_type()

virtual TypeHandle XFileDataNodeReference::get_type | ( |  | ) | const
| inline virtual

Reimplemented from XFileDataNode.

Definition at line 58 of file xFileDataNodeReference.h.

## ◆ init_type()

static void XFileDataNodeReference::init_type | ( |  | ) |
| inline static

Definition at line 53 of file xFileDataNodeReference.h.

## ◆ is_complex_object()

bool XFileDataNodeReference::is_complex_object | ( |  | ) | const
| virtual

Returns true if this kind of data object is a complex object that can hold nested data elements, false otherwise.

Reimplemented from XFileDataObject.

Definition at line 56 of file xFileDataNodeReference.cxx.

## ◆ is_reference()

bool XFileDataNodeReference::is_reference | ( |  | ) | const
| virtual

Returns true if this node represents an indirect reference to an object defined previously in the file.

References are generally transparent, so in most cases you never need to call this, unless you actually need to differentiate between references and instances; you can simply use the reference node as if it were itself the object it references.

If this returns true, the node must be of type XFileDataNodeReference.

Reimplemented from XFileNode.

Definition at line 47 of file xFileDataNodeReference.cxx.

## ◆ write_text()

void XFileDataNodeReference::write_text | ( | std::ostream & | out,
|  | int | indent_level ) const
| virtual

Writes a suitable representation of this node to an .x file in text mode.

Reimplemented from XFileNode.

Definition at line 64 of file xFileDataNodeReference.cxx.

References indent().

The documentation for this class was generated from the following files:

- pandatool/src/xfile/xFileDataNodeReference.h
- pandatool/src/xfile/xFileDataNodeReference.cxx
- pandatool/src/xfile/xFileDataNodeReference.I